#ifndef _Thread_h_
#define _Thread_h_

#include "pthread.h"
#include "iostream"

class Thread{
public:
  void start();
  
  void waitToComplete() { pthread_join(tid, 0); }
  
  static void dispose(Thread* t){
    t->waitToComplete();
    delete t;
  }
  
protected:
  virtual void run() = 0;

  virtual ~Thread() {}
  
  static void* starter(void* thread);
  
  pthread_t tid;
};

#endif // _Thread_h_
