#include <iostream>
//#include "./hederi/izvestac_poruke.h"
//#include "./hederi/SocketException.h"
#include "./hederi/konverzije.h"
#include "./hederi/izvestac.h"
#include "./hederi/pristupna_nit.h"
#include <string>
#include <exception>
using namespace std;


vector<Pristupna_nit*> Pristupna_nit::pristupi;
Semaphore Pristupna_nit::sem_posl(0);
Semaphore Pristupna_nit::mutex(1);
int Pristupna_nit::count(0);

void Pristupna_nit::inc_count(){
	mutex.wait();
	count++;
	cout<<"trenutno ima aktivnih pristupa : "<<count<<endl;
	mutex.signal();
}

void Pristupna_nit::dec_count(){
	mutex.wait();
	count--;
	cout<<"trenutno ima aktivnih pristupa : "<<count<<endl;
	mutex.signal();
}

void Pristupna_nit::cekaj_sve(){
	sem_posl.wait();
	int duz=pristupi.size();
	for (int i=0;i<duz;i++){
		mutex.wait();
		Pristupna_nit* p=pristupi[i];
		mutex.signal();
		p->waitToComplete();
	}
	for (int i=0;i<duz;i++){
		mutex.wait();
		Pristupna_nit* p=pristupi[i];
		mutex.signal();
		delete p;
	}
}

Pristupna_nit::Pristupna_nit(ServerSocketData &serv):server(serv){
	mutex.wait();
	pristupi.push_back(this);
	mutex.signal();
}

//vector<Izvestac_poruke> izvestaci;

void Pristupna_nit::izvestavanje(){
	string naslov;
	try{
		new_sock >> naslov;
	}catch(SocketException e){
		cout<<"greska u komunikaciji\n";
		return;
	}
	cout<<"novi izvestac : "<<naslov<<endl;
	Izvestac_poruke *pizv=new Izvestac_poruke(new_sock,naslov);

	int p=izvestac.prijava(pizv);
	pizv->prenos();
//				cout<<"odjavljuje se "<<p<<endl;
	izvestac.odjava(p);

//				cout<<"odjavljuje se "<<endl;
//				cout<<"odjavio sam se\n";
	cout<<"izvestac : "<<naslov<<" se odjavljuje"<<endl;
}

void Pristupna_nit::pracenje(){
	try{
		Vektor_str vekt;
		vector<unsigned> kljuc;
		izvestac.lista(vekt,kljuc);
		
//				cout<<kljuc;
		new_sock<<vekt;
				
//				cout<<vekt;
		if (vekt.size()==0) return;
//		cout<<"pratilac se odjavljuje\n";
		vector<unsigned> selekcija;
		new_sock>>selekcija;
		if (selekcija.size()==0) return;
//		cout<<"pratilac se odjavljuje\n";
	
//				cout<<selekcija;
		Pratilac_poruke pratilac(new_sock);
		vector<string> poc=izvestac.prijava(&pratilac,selekcija,kljuc);
				
//				cout<<selekcija;
//				cout<<poc;
		pratilac.prenos(poc);
	}catch(SocketException e){
		cout<<"komunikacija sa pratiocem je prekinuta\n";
	}
}
	
void Pristupna_nit::run(){
//	cout << "pristupna nit....\n";
	try{
		// Create the socket
		// novi pristup
		server.accept ( new_sock );
		
		string tip;
		new_sock>>tip;
		char c=tip[0];
//		cout << "new client\n";
		if (c!='i' && c!='p'){
			cout<<"server ce se pogasiti kada zavrse svi klijenti\n";
			delete &server;
			sem_posl.signal();
		}else{
//			cout<<"nov pristup\n";
			(new Pristupna_nit(server))->start();
		}
		
		switch(c){
			case 'i':{
/*
				cout<<"novi izvestac : ";

				string naslov;
				new_sock >> naslov;
				cout<<naslov<<endl;
				Izvestac_poruke izv(new_sock,naslov);
			
				int p=izvestac.prijava(&izv);
				izv.prenos();
//				cout<<"odjavljuje se "<<p<<endl;
				izvestac.odjava(p);

//				cout<<"odjavljuje se "<<endl;
//				cout<<"odjavio sam se\n";
				cout<<"izvestac : "<<naslov<<" se odjavljuje"<<endl;
*/				
				inc_count();
				izvestavanje();
				dec_count();
				break;
			}
			case 'p':{
/*
				cout<<"novi pratilac\n";
				
				Vektor_str vekt;
				vector<unsigned> kljuc;
				izvestac.lista(vekt,kljuc);
//				cout<<kljuc;
				new_sock<<vekt;
				
//				cout<<vekt;
				vector<unsigned> selekcija;
				new_sock>>selekcija;
				if (selekcija.size()==0) break;
				
//				cout<<selekcija;
				Pratilac_poruke pratilac(new_sock);
				vector<string> poc=izvestac.prijava(&pratilac,selekcija,kljuc);
				
//				cout<<selekcija;
//				cout<<poc;
				pratilac.prenos(poc);
				cout<<"pratilac se odjavljuje\n";
*/
				inc_count();
				cout<<"novi pratilac\n";
				pracenje();
				cout<<"pratilac se odjavljuje\n";
				dec_count();
				break;
			}
		}
	}
	catch ( SocketException& e ){
		cout << "Exception was caught:" << e.description() << "\nExiting.\n";
	}
	catch ( exception& e ){
		cout << e.what() << "\nExiting.\n";
	}
//	cout<<"pristupna nit je zavrsena\n";
}
