#include <iostream>
#include "./hederi/konverzije.h"
#include "./hederi/pristupna_nit.h"
#include "./hederi/ServerSocketData.h"
using namespace std;

static const unsigned default_port=3000;

int main(int argc, char *argv[]){
	unsigned port;
	switch (argc){
		case 1 : port=default_port; break;
		case 2 :{
			port=atoi(argv[1]);
			if (port==0){
				cout<<"neispravan argument port= "<<argv[1]<<endl;
				return 1;
			}
			break;
		}
		default: cout<<"neispravan broj argumenata"<<endl; return 2;
	}
	cout << "server se pokrece na port= "<<port<<endl;
	try{
		ServerSocketData *server=new ServerSocketData(port);
		(new Pristupna_nit(*server))->start();
		Pristupna_nit::cekaj_sve();
	}catch(SocketException s){
		cout<<"port "<<port<<" nije pristupacan za server"<<endl;
		return 3;
	}
	cout << "server je zavrsio" << endl;
	return 0;
}
